import numpy as np

def f(x):
    return (x-1)*(x-1)-1

def df(x):
    return 2*(x-1)

def newton(f,x0,eps=1e-8):
    x=x0-f(x0)/df(x0)
    while abs(x-x0)>eps:
        x0=x
        x=x0-f(x0)/df(x0)
    return x

a=1.0
b=10.0
for eps in np.logspace(0,-12,13):
    print("eps={:e},x*={:1.16f}".format(eps,newton(f,10,eps)))

