#%%
import numpy as np
import time

def sinslow(x):
    res=x
    temp=x
    n=0
    while abs(x)>1e-8 and abs(temp)/abs(res)>1e-16:
        n+=1
        temp=-temp*x*x/(2*n*(2*n+1))
        res+=temp
        
    return res

def sinfast(x):
    # reduction interval de x
    
    return sinslow(x)


for i in range(1,5):

    t0=time.time()
    s1=np.sin(10*np.pi/i)
    t1=time.time()-t0

    t0=time.time()
    s2=sinslow(10*np.pi/i)
    t2=time.time()-t0   
    
    t0=time.time()
    s3=sinfast(10*np.pi/i)
    t3=time.time()-t0   

    print("i={}, sin={:1.16f}, sinslow={:1.16}, sinfast={:1.16} ".format(i,s1,s2, s3))
    print('Time elapsed sin:{:1.8f},  sinslow:{:1.8f}, sinfast:{:1.8f}'.format(t1,t2, t3))




